=== debian/changelog ===
zmap (1.1.0-1) unstable; urgency=low

  * Initial release.

 -- Clint Adams <clint@debian.org>  Tue, 10 Dec 2013 21:40:04 -0500
