=== debian/control ===
Source: zmap
Section: net
Priority: optional
Maintainer: Clint Adams <clint@debian.org>
Build-Depends: debhelper (>= 9), cmake, libgmp-dev, libpcap-dev, gengetopt, byacc, flex, libjson-c-dev, pkg-config
Standards-Version: 3.9.5
Homepage: https://zmap.io/
Vcs-Git: git://git.debian.org/collab-maint/zmap.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/zmap.git;a=summary

Package: zmap
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: network scanner for researchers
 ZMap is a network scanner that enables researchers to
 easily perform Internet-wide network studies. With a single
 machine and a well provisioned network uplink, ZMap is capable of
 performing a complete scan of the IPv4 address space in under 45
 minutes, approaching the theoretical limit of gigabit Ethernet.
 .
 ZMap can be used to study protocol adoption over time, monitor
 service availability, and help us better understand large systems
 distributed across the Internet.
