=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_HARDENING=ON # -DWITH_JSON=ON
