=== debian/changelog ===
zmap (1.2.0-1~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.
  * No source changes required.

 -- Wessel Dankers <wsl@fruit.je>  Wed, 11 Jun 2014 10:27:37 +0200

zmap (1.2.0-1) unstable; urgency=medium

  * Imported Upstream version 1.2.0

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Mon, 10 Mar 2014 20:31:27 +0100

zmap (1.1.2-2) unstable; urgency=medium

  * Added json support
  * Added patch to fix spelling error in redis.c
  * Added redis support

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Thu, 06 Mar 2014 12:46:42 +0100

zmap (1.1.2-1) unstable; urgency=medium

  * New maintainer (Closes: #738468)
  * Added watch file
  * debian/copyright added new maintainer
  * debian/control
    - spelling fix
    - fixed Vcs fields to be canonical
  * debian/patches/02-fix-hyphenation-in-man
    - fixes hyphen-used-as-minus-sign in zmap.1
  * New upstream version 

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Tue, 18 Feb 2014 23:35:49 +0100
