## zmap 1.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,12 @@
 cmake_minimum_required (VERSION 2.6)
 project (ZMAP C)
-SET (VERSION 1.2.0)
+SET (VERSION 1.2.1)
 
 option(WITH_REDIS "Build with support for Redis DB" OFF)
 option(WITH_JSON "Build with support for JSON" OFF)
 option(ENABLE_DEVELOPMENT "Enable development specific compiler and linker flags" OFF)
 option(RESPECT_INSTALL_PREFIX_CONFIG "Respect CMAKE_INSTALL_PREFIX for /etc" OFF)
+option(WITH_WERROR "Build with -Werror" OFF)
 
 if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
 	set(USING_CLANG "YES")
@@ -32,8 +33,11 @@
 # Fix line breaks
 string(REPLACE ";" " "  GCCWARNINGS "${GCCWARNINGS}")
 
+if(WITH_WERROR)
+	set(GCCWARNINGS "${GCCWARNINGS} -Werror")
+endif()
+
 if(ENABLE_DEVELOPMENT)
-	set(GCCWARNINGS "${GCCWARNINGS} -Werror")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ggdb")
 	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -g")
 else()
