=== debian/changelog ===
zmap (1.2.1-1) unstable; urgency=medium

  * Spelling patch added
  * Imported Upstream version 1.2.1

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Mon, 30 Jun 2014 13:22:28 +0200
