=== debian/control ===
Source: zmap
Section: net
Priority: optional
Maintainer: Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>
Build-Depends:
 byacc,
 cmake,
 debhelper (>= 9),
 flex,
 gengetopt,
 libgmp-dev,
 libhiredis-dev,
 libjson-c-dev,
 libpcap-dev,
 pkg-config
Standards-Version: 3.9.5
Homepage: https://zmap.io/
Vcs-Git: git://anonscm.debian.org/collab-maint/zmap.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/zmap.git;a=summary

Package: zmap
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: network scanner for researchers
 ZMap is a network scanner that enables researchers to
 easily perform Internet-wide network studies. With a single
 machine and a well provisioned network uplink, ZMap is capable of
 performing a complete scan of the IPv4 address space in under 45
 minutes, approaching the theoretical limit of gigabit Ethernet.
 .
 ZMap can be used to study protocol adoption over time, monitor
 service availability, and help people better understand large systems
 distributed across the Internet.
