=== debian/changelog ===
zmap (2.1.1-2) unstable; urgency=medium

  * Refreshed 02fix_conffiles to install conffile (Closes: #802641)

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Thu, 29 Oct 2015 09:07:58 +0100

zmap (2.1.1-1) unstable; urgency=medium

  * Imported Upstream version 2.1.1
  * d/patches:
    - 01fix_ronn_files removed, fixed in upstream
    - 02fix_conffiles refreshed
    - fix_build_in_Debian added to fix cmake paths  
  * wrap-and-sorted 
  * added udp-probes to d/zmap.examples

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Fri, 02 Oct 2015 15:07:14 +0200

zmap (2.1.0-1) unstable; urgency=medium

  * Imported Upstream version 2.1.0
  * d/control: Bump standards to 3.9.6, no changes needed
  * d/patches/01fix_ronn_files.patch: Generating man pages with whatis
    header
  * d/patches/02fix_conffiles.patch: Fix for conffiles installing in etc

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Tue, 08 Sep 2015 16:16:13 +0200
