=== debian/control ===
--- 
+++ 
@@ -2,25 +2,25 @@
 Section: net
 Priority: optional
 Maintainer: Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>
-Build-Depends:
- byacc,
- cmake,
- debhelper (>= 9),
- flex,
- gengetopt,
- libgmp-dev,
- libhiredis-dev,
- libjson-c-dev,
- libpcap-dev,
- pkg-config
-Standards-Version: 3.9.5
+Build-Depends: byacc,
+               cmake (>= 2.8.12),
+               debhelper (>= 9),
+               flex,
+               gengetopt,
+               libgmp-dev,
+               libhiredis-dev,
+               libjson-c-dev,
+               libpcap-dev,
+               pkg-config,
+Standards-Version: 3.9.6
 Homepage: https://zmap.io/
 Vcs-Git: git://anonscm.debian.org/collab-maint/zmap.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/zmap.git;a=summary
 
 Package: zmap
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
 Description: network scanner for researchers
  ZMap is a network scanner that enables researchers to
  easily perform Internet-wide network studies. With a single
